﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.IO;
using System.Xml;
using System.Xml.Schema;

namespace SchemaValidation
{
  public class SchemaValidator
  {
    public bool ValidationErrors = false;

    public void ValidateXML(string XMLFile, string XSDFile)
    {
      this.ValidationErrors = false;

      FileStream xsdStream = new FileStream(XSDFile, FileMode.Open);
      FileStream xmlStream = new FileStream(XMLFile, FileMode.Open);

      XmlReader schemaReader = XmlReader.Create(xsdStream);

      XmlReaderSettings readerSettings = new XmlReaderSettings();
      readerSettings.ValidationType = ValidationType.Schema;
      readerSettings.Schemas.Add("", schemaReader);
      readerSettings.ValidationEventHandler += OnValidate;

      this.ValidationErrors = false;
      XmlReader xr = XmlReader.Create(xmlStream, readerSettings);
      using (xr)
        while (xr.Read()) ;

      xsdStream.Close();
      xmlStream.Close();
    }

    private void OnValidate(object sender, ValidationEventArgs e)
    {
      this.ValidationErrors = true;
      Console.WriteLine(e.Message);
    }

  }
}
